SystemOrganization addCategory: #'Services-Old'!
SystemOrganization addCategory: #'Services-Base'!
SystemOrganization addCategory: #'Services-Base-Tests'!
SystemOrganization addCategory: #'Services-RB'!

!MenuMorph methodsFor: '*services-utilities' stamp: 'rr 3/16/2004 19:46'!
infos
	| coll |
	coll := self items collect: [:each |
			{ each contentString. each target. each selector. each arguments.}].
	coll explore. ! !

!ChildrenToSiblingsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 22:25'!
helpText
	^ 'Creates a new class which will the selected
	class'' superclass. You will then be prompted 
	to choose some of the subclasses of this class.
	Those classes will become subclasses of the
	new class (they''re pushed up). 
	
	Warning : this refactoring involves quite 
	a lot of recompilation, so be patient'! !

!ChildrenToSiblingsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:28'!
name: aClassName class: aClass subclassesNames: subclassCollection 
	^self name: aClassName
			class: aClass
			subclasses: (subclassCollection collect: [:each | Smalltalk at: each])
! !

!ChildrenToSiblingsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:32'!
service
	^ Service new label: 'Convert subclasses to sibling classes';
				shortLabel: 'sibling';
				action: [:class :newSuperClass :subclassesToMoveCollection |
					(self name: newSuperClass class: class 
							subclassesNames: subclassesToMoveCollection) execute] ! !

!ChildrenToSiblingsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:02'!
categories
	^ {self classrc}! !

!ChildrenToSiblingsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:58'!
parameters
	^ #(newClassName class siblingClassNameCollection)! !

!ChildrenToSiblingsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:27'!
constructor
	^ #name:class:subclassesName: ! !

Object subclass: #Service
	instanceVariableNames: 'condition action conditionParameters actionParameters requestor resultAction label shortLabel description enabled'
	classVariableNames: 'Services'
	poolDictionaries: ''
	category: 'Services-Base'!

Service class
	instanceVariableNames: 'b s'!

!Service commentStamp: 'rr 3/16/2004 21:06' prior: 0!
Todo : add enabled and categories!

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 09:06'!
resultAction: anObject
	resultAction := anObject! !

!Service methodsFor: 'accessing' stamp: 'rr 3/17/2004 11:07'!
condition: aBlock
	"self halt."
	aBlock fixTemps.
	condition := aBlock.
	conditionParameters := aBlock arguments.! !

!Service methodsFor: 'accessing' stamp: 'rr 3/17/2004 16:49'!
description: anObject
	description := anObject select: [:each | (each = Character cr) not] 
						thenCollect: [:each | each = Character tab ifTrue: [Character space]
															ifFalse: [each]].! !

!Service methodsFor: 'executing' stamp: 'rr 3/16/2004 09:06'!
execute
	| answer |
	answer := action valueWithArguments: self collectActionArguments.
	resultAction value: answer.! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:58'!
action
	^action! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 09:05'!
shortLabel: anObject
	shortLabel := anObject! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 22:53'!
test
	Service initialize.
	s := ServiceCategory new.
	Service root addService: s.
	self initializeRootForRB.
	b := Service root asButton.
	b color: Color white.
	b extent: 100 @ 100.
	b position: 100 @ 100.
	b openInWorld! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 21:13'!
enabled: aBoolean
	enabled := aBoolean! !

!Service methodsFor: 'initialize-release' stamp: 'rr 3/17/2004 18:35'!
initialize
	self action: [].
	self condition: [true].
	self label: 'no op'.
	self requestor: Requestor new.
	self resultAction: [:answer | ].
	self enabled: true.! !

!Service methodsFor: 'executing' stamp: 'rr 3/16/2004 21:11'!
executeCondition
	^ condition valueWithArguments: self collectConditionArguments.! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 22:21'!
initialize
	"Service initialize"
	"This is the only category where we dont use #named"
	Services := ServiceCategory new.
	Services label: 'Root Category'.
	Services description: 'This is the service category containing all the referenced services.
		it provides an acces point to find all the other services'.
	Services shortLabel: 'root'! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:59'!
requestor: anObject
	requestor := anObject! !

!Service methodsFor: 'gui building' stamp: 'rr 3/16/2004 21:15'!
asMenuItemFor: aMenu
	"Returns a menuItem triggering self"
	aMenu addUpdating: #label target: self action: #execute.
	aMenu balloonTextForLastItem: self description. ! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:59'!
requestor
	^requestor! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:58'!
condition
	^condition! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 09:07'!
shortLabel
	^shortLabel ifNil: [label] ifNotNil: [shortLabel]! !

!Service class methodsFor: 'registering' stamp: 'rr 3/17/2004 18:03'!
categoryNamed: catName
	^ Services findCategoryNamed: catName! !

!Service methodsFor: 'executing' stamp: 'rr 3/16/2004 21:10'!
isEnabled
	^ enabled and: [self executeCondition]! !

!Service class methodsFor: 'registering' stamp: 'rr 3/17/2004 15:55'!
register: aService underCategories: categories 
	categories do: [:eachCategory | self root addService: aService under:  eachCategory].! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 21:00'!
description
	^description ifNil: [label] ifNotNil: [description]! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 19:22'!
endTest
	Utilities closeAllDebuggers.
	MenuMorph allInstances do: [:each | each delete] .
	b delete.
	Services := nil! !

Service subclass: #ServiceCategory
	instanceVariableNames: 'services myMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceCategory commentStamp: 'rr 3/15/2004 10:03' prior: 0!
I represent a category of services able to be added to a menu.
I can also be used as a menu or button to display my subservices, 
and maybe filtering them dynamically depending on the requestor's
state. interesting for class, methods refactoring specific for
testcases.!

!ServiceCategory methodsFor: 'subservices' stamp: 'rr 3/17/2004 18:05'!
addService: aService under: categoryName 
	| cat |
	cat := self findCategoryNamed: categoryName.
	cat addService: aService.
	^ aService! !

!ServiceCategory methodsFor: 'subservices' stamp: 'rr 3/17/2004 22:09'!
addService: aService
	(services includes: aService) ifFalse: [services add: aService.].
	^ aService
	! !

!ServiceCategory methodsFor: 'accessing' stamp: 'rr 3/16/2004 22:13'!
categoryName
	^self label! !

!ServiceCategory methodsFor: 'gui building' stamp: 'rr 3/16/2004 19:37'!
addEmptyItem
	| noOp |
	noOp := Service new.
	noOp label: 'empty category'.
	noOp description: 'sorry, this category is empty'.
	noOp asMenuItemFor: myMenu! !

!ServiceCategory methodsFor: 'gui building' stamp: 'rr 3/16/2004 22:15'!
initialize
	super initialize.
	services := OrderedCollection new.
	myMenu := MenuMorph new.
	self label: 'unnamed category'! !

!ServiceCategory methodsFor: 'gui building' stamp: 'rr 3/17/2004 10:26'!
buildMenu
	self initializeMenu.
	
	services do: 
			[:each | 
			each requestor: self requestor.
			each isEnabled ifTrue: [each asMenuItemFor: myMenu]].
	myMenu items isEmpty ifTrue: [self addEmptyItem].! !

!ServiceCategory methodsFor: 'subservices' stamp: 'rr 3/17/2004 18:02'!
findCategoryNamed: categoryName
	| name cat subName |
	categoryName ifEmpty: [^ self].
	name := categoryName copyUpTo: self categorySeparator.
	subName := categoryName copyAfter: self categorySeparator.
	cat := self subCategoryNamed: name.
	^ cat findCategoryNamed: subName.! !

!ServiceCategory methodsFor: 'subservices' stamp: 'rr 3/16/2004 22:13'!
subCategoryNamed: name 
	^services detect: [:each | each categoryName = name]
		ifNone: 
			[| category |
			category := ServiceCategory named: name.
			self addService: category]! !

!ServiceCategory methodsFor: 'gui building' stamp: 'rr 3/16/2004 22:58'!
initializeMenu
	myMenu removeAllMorphs.
	myMenu selectItem: nil event: nil.
	myMenu title: self label translated.
	"myMenu addStayUpItem." "seems a bad idea"
	myMenu setBalloonText: self description! !

!ServiceCategory methodsFor: 'gui building' stamp: 'rr 3/16/2004 19:36'!
asMenuItemFor: aMenu 
	"Returns a menuItem triggering self's submenu"

	self buildMenu.
	aMenu 
		add: self label translated
		subMenu: myMenu
		target: self
		selector: #execute
		argumentList: #().
	aMenu balloonTextForLastItem: self description.
	aMenu lastItem 
		on: #mouseEnter
		send: #execute
		to: self! !

!ServiceCategory methodsFor: 'accessing' stamp: 'rr 3/17/2004 22:05'!
categorySeparator
	^$/! !

!ServiceCategory methodsFor: 'executing' stamp: 'rr 3/16/2004 22:57'!
execute
	"displays the subservices as a submenu"

	"myMenu commandKeyHandler: self"

	"do command handling later."

	self buildMenu.
	"services do: 
			[:each | 
			each requestor: self requestor.
			each isEnabled ifTrue: [each asMenuItemFor: myMenu]]."
	myMenu popUpInWorld! !

!ServiceCategory class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 22:22'!
named: categoryName
	| newCat |
	newCat := self new label: categoryName.
	Service root addService: newCat.
	^ newCat.! !

!Service methodsFor: 'gui building' stamp: 'rr 3/16/2004 09:07'!
asButton
	| aButton |
	aButton := PluggableButtonMorph 
				on: self
				getState: nil
				action: #execute.
	aButton
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		useRoundedCorners;
		label: self shortLabel;
		askBeforeChanging: true;
		onColor: Color transparent offColor: Color transparent.
	aButton setBalloonText: self description.
	Preferences alternativeWindowLook 
		ifTrue: 
			[aButton
				borderWidth: 2;
				borderColor: #raised].
	^aButton! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/17/2004 18:33'!
root
	^ Services! !

!Service methodsFor: 'accessing' stamp: 'rr 3/17/2004 11:07'!
action: aBlock
	aBlock fixTemps.
	action := aBlock.
	actionParameters := aBlock arguments! !

!Service methodsFor: 'executing' stamp: 'rr 3/16/2004 21:12'!
collectConditionArguments
	^ (conditionParameters collect: [:each | requestor request: each]) asArray! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 22:53'!
initializeRootForRB
	Service root addService: ExtractMethodRefactoring service
		under: 'Refactorings/Method Refactorings'! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 21:13'!
enabled
	^ enabled! !

!Service methodsFor: 'executing' stamp: 'rr 3/16/2004 21:11'!
collectActionArguments
	^ (actionParameters collect: [:each | requestor request: each]) asArray! !

!Service methodsFor: 'executing' stamp: 'rr 3/16/2004 22:48'!
executeWith: aRequestor
	self requestor: aRequestor.
	self execute.! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 19:33'!
bar
	s addService: Service new! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:59'!
label
	^label! !

!Service class methodsFor: 'registering' stamp: 'rr 3/17/2004 17:52'!
categegory: catName
	Services findCategoryNamed: catName! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 22:17'!
categoryName
	"a service has no category name"
	^ ''! !

!Service methodsFor: 'accessing' stamp: 'rr 3/17/2004 16:48'!
label: aString
	label := aString translated! !

!Service methodsFor: 'accessing' stamp: 'rr 3/16/2004 09:06'!
resultAction
	^resultAction! !

!Service class methodsFor: 'as yet unclassified' stamp: 'rr 3/16/2004 19:33'!
foo
	Service root addService: Service new! !

Object subclass: #ServiceOld
	instanceVariableNames: 'provider requestor description selector parameters enabled label'
	classVariableNames: 'Services'
	poolDictionaries: ''
	category: 'Services-Old'!

!ServiceOld commentStamp: 'rr 3/14/2004 17:24' prior: 0!
I represent a service provided by an application. I am therefore an object which can be
executed on itself, and able to be inserted in standard graphical elements, such as menus
and button bars. Since I am standalone, I can also be manipulated without a gui if needed.

I am invoqued by a requestor, to which I forward requests. Depending on where  I am
invoked, this requests can be answered by a different object, such as a Browser, or
directly by the user if needed. I have a collection of parameter types that I need to
perform the selector, and I query my requestor to collect the actual arguments.

Instances of me are registered in global variables, and  can then be used in various contexts.
I am able to answer to various queries to know when I should be displayed.

One may use me to implement the following types of services :
-ClassService
-MethodService
-ClassCategoryService
-MethodCategoryService
-SourceCodeSelectionService
-WorldMenuService
-FileService

Note that refactorings for example might be located in several of these categories.!

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 21:54'!
requestor: newRequestor
	requestor := newRequestor! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:24'!
provider
	^provider! !

!ServiceOld class methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 19:56'!
servicesFor: serviceCategory
	"returns the services associated with this category"
	Services ifNil: [Services := Dictionary new].
	^ Services at: serviceCategory ifAbsentPut: [OrderedCollection new].! !

!ServiceOld methodsFor: 'gui building' stamp: 'rr 3/15/2004 09:54'!
asButton
	| aButton |
	aButton := PluggableButtonMorph 
				on: self
				getState: nil
				action: #execute.
	aButton
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		useRoundedCorners;
		label: self label;
		askBeforeChanging: true;
		onColor: Color transparent offColor: Color transparent.
	aButton setBalloonText: self description.
	Preferences alternativeWindowLook 
		ifTrue: 
			[aButton
				borderWidth: 2;
				borderColor: #raised].
	^aButton! !

!ServiceOld class methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 20:00'!
registerService: service under: categories
	categories do: [:cat | self at: cat add: service]! !

!ServiceOld class methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 19:57'!
enabledServicesFor: serviceCategory
	"returns the services associated with this category"
	^ (self servicesFor: serviceCategory) collect: [:each | each isEnabled]! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 09:52'!
description: anObject
	description := anObject! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:24'!
parameters
	^parameters! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:25'!
selector: anObject
	selector := anObject! !

ServiceOld subclass: #RefactoringService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Old'!

!RefactoringService methodsFor: 'as yet unclassified' stamp: 'rr 3/15/2004 23:06'!
execute
	
	| theRefactoring |
	theRefactoring := super execute.
	theRefactoring execute.! !

!RefactoringService class methodsFor: 'as yet unclassified' stamp: 'rr 3/14/2004 23:02'!
forClass: aRefactoringClass
	^ self new forClass: aRefactoringClass! !

!RefactoringService methodsFor: 'as yet unclassified' stamp: 'rr 3/14/2004 23:07'!
forClass: refactoring
	self provider: refactoring 
		selector: refactoring constructor 
		requestor: Requestor new
		parameters: refactoring parameters 
		description:  refactoring helpText.
	! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 09:37'!
label
	 label ifNil: [ self label: self computeLabel].
	^ label! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 19:58'!
disable
	enabled := false.! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 19:58'!
provider: p selector: s requestor: r parameters: pr description: d 
	provider := p.
	selector := s.
	requestor := r.
	parameters := pr.
	description := d.
	enabled := true! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/15/2004 10:39'!
requestor
	^ requestor! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:24'!
parameters: anObject
	parameters := anObject! !

!ServiceOld class methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 18:13'!
provider: p selector: aSymbol requestor: r parameters: anArray 
	^ self provider: p selector: aSymbol requestor: r parameters:  anArray description: ''! !

!ServiceOld methodsFor: 'as yet unclassified' stamp: 'rr 3/15/2004 09:56'!
computeLabel
	"By default, this is the service provider name"
	^ provider name! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 21:55'!
isEnabledForRequestor
	"tells if the service is enabled for the current requestor"
	^ true! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 19:58'!
enable
	enabled := true.! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 19:52'!
todo
	"Service register: aService categories: 'anArray'
	Service browseServices : gui to offer to enable/disable services
	
	categories
	-Messages
	-Classes
	-ClassCategories
	-MethodCategories
	-Selection
	-CodeSelection
	"! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:13'!
description
	"answers the label if no help text is set"
	^description ifNil: [label] ifNotNil: [description]! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/15/2004 11:26'!
initialize
	"put a default requestor"
	requestor := Requestor new.	! !

!ServiceOld methodsFor: 'gui building' stamp: 'rr 3/15/2004 10:35'!
asMenuItemFor: aMenu
	"Returns a menuItem triggering self"
	aMenu addUpdating: #label target: self action: #execute.
	aMenu balloonTextForLastItem: self description. ! !

!ServiceOld class methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 18:13'!
provider: p selector: aSymbol requestor: r parameters: anArray description: aString
	^ self new provider: p selector: aSymbol requestor: r parameters:  anArray description: aString! !

!ServiceOld class methodsFor: 'initialize-release' stamp: 'rr 3/15/2004 10:37'!
at: cat add: serv
	| categ |
	categ := self at: cat ifAbsentPut: [ServiceCategory new].
	categ addService: serv.! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:24'!
provider: anObject
	provider := anObject! !

ServiceOld subclass: #MethodService
	instanceVariableNames: 'cm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Old'!

!MethodService methodsFor: 'as yet unclassified' stamp: 'rr 3/15/2004 15:18'!
forMethod: comp
	| w ref node comments |
	cm := comp.
	w := cm who.
	ref := MethodReference class: w first selector:  w second.
	node := Parser new parse: ref source class: ref actualClass.
	comments := node comment.
	parameters := (node tempNames first: cm numArgs) asArray. 
	comments ifNotNil: [
	comments size = 2 ifTrue: [label := comments first. description := comments second]
					ifFalse: [label := comments first]].
	selector := node selector.
	provider := w first theNonMetaClass.
! !

!ServiceOld methodsFor: 'executing' stamp: 'rr 3/15/2004 11:42'!
execute
	"Todo : determine what to do with the result. 
	-If a string, display it?
	-If a collection, make a menu for it ?"
	| actualParameters result |
	actualParameters := self collectArguments asArray.
	result := provider perform: selector withArguments: actualParameters.
	^result! !

!ServiceOld methodsFor: 'initialize' stamp: 'rr 3/14/2004 19:58'!
isEnabled
	^ enabled! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 11:25'!
selector
	^selector! !

!ServiceOld methodsFor: 'executing' stamp: 'rr 3/14/2004 17:56'!
collectArguments
	^parameters collect: [:each | requestor request: each]! !

!ServiceOld class methodsFor: 'services' stamp: 'rr 3/15/2004 15:17'!
browseSendersOf: selectorName in: class using: systemNavigation
	"local senders of ..."
	"Browse the senders of this selector in the browsed class"
	systemNavigation browseAllCallsOn: selectorName from: class! !

!ServiceOld methodsFor: 'accessing' stamp: 'rr 3/15/2004 09:38'!
label: anObject
	label := anObject! !

!ServiceOld class methodsFor: 'registering' stamp: 'rr 3/15/2004 19:01'!
register: aClass
	"Register all services defined by a class. These services are defined in the
	services category of the class"
	| services |
	services := (aClass class allMethodsInCategory: 'services') 
						collect: [:each | (aClass class >> each) asService].
						! !

Object subclass: #BarBar
	instanceVariableNames: 'bur'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/17/2004 10:43'!
foo
	| fuche b1 b2 b3 |
	fuche := 45.
	b1 := [:a :b :c | fuche].
	b2 := [:a :b :d | fuche squared negated].
	b3 := [:a :e | e sqrt].
	b2 arguments! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/15/2004 14:04'!
cagadeFromBur: selector 
	^selector cagadeFuche! !

!BarBar class methodsFor: 'as yet unclassified' stamp: 'rr 3/15/2004 15:11'!
fuche: class
	^ class! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/17/2004 17:35'!
machinFuche: bar 
	self getBar: (self sumBurWith: bar)! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/16/2004 22:41'!
getBarBar: bar 
	self getBarGiving: bar! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/16/2004 22:39'!
sumBurWith: bar 
	^bar + bur! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/17/2004 17:35'!
getBarGiving: bar 
	self machinFuche: bar! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/15/2004 15:05'!
cagadeFor: selector 
	"make a cagade"
	"Makes a cagade with the specified selector"
	| barbur |
	barbur := 4.
	barbur squared.
	^(self class canUnderstand: selector) 
		ifTrue: [selector]
		ifFalse: [bur cagadeFromBur: selector]! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/15/2004 09:24'!
returnReturnReturn42
	^self return42! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/15/2004 13:20'!
foo: bar 
	self getBarBar: bar.
	^self returnReturnReturn42! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/14/2004 23:27'!
return42
	^42! !

!BarBar methodsFor: 'barbaring' stamp: 'rr 3/15/2004 13:20'!
getBar: bar 
	bar isNil ifTrue: [42]! !

Object subclass: #RefactoringFactory
	instanceVariableNames: 'parameters refac'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-RB'!

!RefactoringFactory commentStamp: 'rr 3/11/2004 13:26' prior: 0!
This class attemps to build a refactoring given it's class,
handling classname requests, selector and instvar request.
It can also handles the selection of text in a method or a 
class def.!

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 19:44'!
selection
	"Sorry to feedle with fillInTheBlankMorph innards, but I had to"
	| text m |
	text := (MethodReference class: (self findParam: #inClass) 
							selector: (self findParam: #selectorName)) sourceCode.
	m := FillInTheBlankMorph new.
	m setQuery: 'Select a sourcecode part, and accept' initialAnswer: text
		answerExtent: 500@250
		acceptOnCR: true. 
	World addMorph: m centeredNear: World activeHand position.
	m getUserResponse.
	^ m selection! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 18:05'!
protocolName
	^ (FillInTheBlank request: 'enter method category') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 19:33'!
tempVarName
	^(FillInTheBlank request: 'enter a temporary variable name') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 18:15'!
selectorCollection
	^ Array with: (FillInTheBlank request: 'enter selector name') asSymbol! !

!RefactoringFactory class methodsFor: 'queries' stamp: 'rr 3/10/2004 14:17'!
refactorings
	^ Refactoring allSubclasses! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 16:32'!
newVarName
	^ FillInTheBlank request: 'enter variable name'! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 18:19'!
newSelectorName
	^ (FillInTheBlank request: 'Enter new selector name') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 16:31'!
createParam: paramName
	| p |
	p := self perform: paramName.
	parameters at: paramName put: p.
	^ p! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 11:44'!
variableName
	^ (FillInTheBlank request: 'Enter a variable name') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 10:56'!
varNamesCollection
	^ ((FillInTheBlank request: 'enter a list of instance variables') findTokens: ' ') collect:
		[:v | v asSymbol]! !

!RefactoringFactory class methodsFor: 'queries' stamp: 'rr 3/10/2004 14:17'!
standAloneRefactorings
	^ self refactorings select: [:each | each isStandAlone] 
	! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 16:30'!
find: paramName
	^ parameters at: paramName 
				ifAbsent: [self createParam: paramName. parameters at: paramName]! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 22:17'!
classCollection
	^ ((FillInTheBlank request: 'Enter a list of class names') findTokens: ' ')
		collect: [:each | Smalltalk at: each asSymbol]! !

!RefactoringFactory methodsFor: 'as yet unclassified' stamp: 'rr 3/10/2004 16:18'!
doesNotUnderstand: aMessage 
	"if it's a setter, sets in the dictionnary"

	(aMessage selector keywords size = 1 & aMessage selector last) = $: 
		ifTrue: 
			[parameters at: (aMessage selector copyWithout: $:)
				put: aMessage arguments first]
		ifFalse: [super doesNotUnderstand: aMessage]! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 20:53'!
argumentPermutation
	| selector oldArguments oldMethodName newMethodName class source |
	selector := self findParam: #selectorName.
	class := self findParam: #inClass.
	source := (MethodReference class: class selector: selector) sourceCode.
	oldArguments := (RBParser parseMethod: source) argumentNames.
	oldMethodName := RBMethodName selector: selector arguments: oldArguments.
	(newMethodName := MethodNameEditor forMethodName: oldMethodName) 
		ifNil: [^nil].
	^  newMethodName arguments collect: [:e | oldArguments indexOf: e].! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 17:43'!
varName
	^ FillInTheBlank request: 'Enter an instance/class variable name'! !

!RefactoringFactory methodsFor: 'as yet unclassified' stamp: 'rr 3/10/2004 16:15'!
forClass: c 
	parameters := Dictionary new.
	refac := c! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 18:11'!
methodBody
	^ FillInTheBlank request: 'Enter method body'! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 19:05'!
findParam: paramName
	^ parameters at: paramName 
				ifAbsent: [self createParam: paramName]! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 22:14'!
classNameCollection
	^ ((FillInTheBlank request: 'Enter a list of class names') findTokens: ' ')
		collect: [:each | each  asSymbol]! !

!RefactoringFactory methodsFor: 'as yet unclassified' stamp: 'rr 3/10/2004 16:17'!
execute
	"automagically finds the arguments for the constructor, builds 
	the refactorings, and performs it.
	TODO : rename the class parameter type to something else"
	| refactoring |
	refactoring := refac perform: refac constructor withArguments: self refactoringArguments.
	refactoring execute.! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 19:43'!
newClassName
	^ (FillInTheBlank request: 'Enter the new class name') asSymbol! !

!RefactoringFactory methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2004 13:27'!
requestClassName
	"asks the user for a class name"
	^ FillInTheBlank request: 'enter a class name'! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 18:03'!
selectorName
	^ (FillInTheBlank request: 'enter selector name') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 19:43'!
categoryName
	^ (FillInTheBlank request: 'Enter the category the class will be defined in: ') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 10:50'!
parameterName
	^ (FillInTheBlank request: 'enter a parameter name') asSymbol! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/11/2004 11:25'!
expression
	^ FillInTheBlank request: 'Enter initializing expression'! !

!RefactoringFactory methodsFor: 'parameters' stamp: 'rr 3/10/2004 16:34'!
inClass
	^ Smalltalk at: (FillInTheBlank request: 'enter class name') asSymbol! !

!RefactoringFactory methodsFor: 'queries' stamp: 'rr 3/10/2004 14:03'!
selectSubclassesOf: aClass 
	"todo : change this so that it works ..."
	| subclasses |
	subclasses := aClass subclasses 
				asSortedCollection: [:a :b | a name < b name].
	subclasses isEmpty ifTrue: [^#()].
	^ChooserMorph 
		choose: 'Choose subclasses:'
		multipleSelect: true
		fromList: subclasses
		values: subclasses
		cancel: [nil]! !

!RefactoringFactory methodsFor: 'asdf' stamp: 'rr 3/10/2004 16:32'!
refactoringArguments
	^ refac parameters collect: [:each | self findParam: each].! !

Object subclass: #Requestor
	instanceVariableNames: 'args caption'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!Requestor commentStamp: 'rr 3/14/2004 17:24' prior: 0!
I am an object used to query parameters to perform services, so that they are standalone.
I can be subclassed to implement various searching strategies. Interesting strategies are :

-ask a browser
-ask directly the user when I am standalone or lost. In that case I can use 
FillInTheBlanks and the like.!

Requestor subclass: #BrowserRequestor
	instanceVariableNames: 'myBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!BrowserRequestor commentStamp: 'rr 3/14/2004 22:18' prior: 0!
I am a requestor specialized to fetch information in a Browser.
I can ask it it's selected class and selected method for example.!

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 3/15/2004 09:18'!
requestSelection
	^ myBrowser selectedInterval! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 3/14/2004 23:29'!
requestSelectorName
	^ myBrowser selectedMessageName! !

!BrowserRequestor methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 23:21'!
browser: b
	myBrowser := b! !

!BrowserRequestor methodsFor: 'as yet unclassified' stamp: 'rr 3/17/2004 10:25'!
requestSelectionNode
	^ myBrowser findSelectionNode! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 3/16/2004 22:34'!
requestSelector
	^ self requestSelectorName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 3/14/2004 23:22'!
requestClass
	^ myBrowser selectedClassOrMetaClass! !

Requestor subclass: #FileListRequestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

Requestor subclass: #ParagraphRequestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ParagraphRequestor commentStamp: 'rr 3/15/2004 11:06' prior: 0!
Might be useful to add a hook there ?!

!Requestor methodsFor: 'requests' stamp: 'rr 3/16/2004 22:39'!
requestSelection
	"Sorry to feedle with fillInTheBlankMorph innards, but I had to"
	| text m |
	text := (MethodReference class: (self request: #class) 
							selector: (self request: #selector)) sourceCode.
	m := FillInTheBlankMorph new.
	m setQuery: 'Highlight a part of the source code, and accept' initialAnswer: text
		answerExtent: 500@250
		acceptOnCR: true. 
	World addMorph: m centeredNear: World activeHand position.
	m getUserResponse.
	^ m selection! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/15/2004 21:35'!
requestSymbol
	^ (self requestString: caption) asSymbol! !

!Requestor methodsFor: 'caching' stamp: 'rr 3/14/2004 18:29'!
cache: parameter category: cat
	(self nonCachedParameters includes: cat) ifFalse: [args at: cat put: parameter] ! !

!Requestor methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 18:33'!
initialize
	args := Dictionary new.! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/14/2004 23:10'!
requestClass: aCaption
	^ Smalltalk at: (self requestSymbol: aCaption)! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/14/2004 23:12'!
requestSymbolCollection
	^ [self requestSymbolCollection: caption] on: ServiceCancelled do: [#()] ! !

!Requestor methodsFor: 'requests' stamp: 'rr 3/14/2004 21:42'!
requestBoolean
	^ PopUpMenu confirm:   'choose a boolean' trueChoice: 'true' falseChoice: 'false'! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/14/2004 19:00'!
requestSymbol: caption
	^ (self requestString: caption) asSymbol! !

!Requestor methodsFor: 'requests' stamp: 'rr 3/15/2004 14:27'!
requestSystemNavigation
	"maybe override in the future to restrict to parts of the image"
	^ SystemNavigation default! !

Requestor subclass: #TestRequestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Tests'!

!TestRequestor methodsFor: 'as yet unclassified' stamp: 'rr 3/14/2004 18:31'!
requestBoolean
	^ true! !

!Requestor methodsFor: 'requests' stamp: 'rr 3/15/2004 21:36'!
requestClass
	^ self requestClass: caption! !

!Requestor methodsFor: 'executing' stamp: 'rr 3/14/2004 22:41'!
fetchSelectorFor: selector 
	^(self class canUnderstand: selector) 
		ifTrue: [selector]
		ifFalse: 
			[(selector endsWith: 'Collection') 
				ifTrue: [#requestSymbolCollection]
				ifFalse: [#requestSymbol]]! !

!Requestor methodsFor: 'executing' stamp: 'rr 3/15/2004 13:39'!
findWordsIn: parameterType 
	| res |
	res := WriteStream 
				with: (parameterType first isVowel ifTrue: ['an '] ifFalse: ['a ']).
	parameterType convertToWordIn: res.
	^res contents! !

!Requestor methodsFor: 'caching' stamp: 'rr 3/14/2004 18:24'!
inCache: aSymbol 
	(self nonCachedParameters includes: aSymbol) 
			ifTrue: [^false]
			ifFalse: [^ args includesKey: aSymbol] 
	! !

!Requestor methodsFor: 'requests' stamp: 'rr 3/17/2004 14:49'!
requestClassCollection
	^ (self requestSymbolCollection: caption) collect: [:className | Smalltalk at: className]! !

!Requestor methodsFor: 'executing' stamp: 'rr 3/15/2004 21:24'!
request: parameterType 
	"This parameter is needed by our service. Answers it"

	(self inCache: parameterType) 
		ifTrue: [^args at: parameterType]
		ifFalse: [^self performRequest: parameterType]! !

!Requestor methodsFor: 'caching' stamp: 'rr 3/14/2004 18:25'!
nonCachedParameters
	^ #(symbol boolean string number)! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/14/2004 19:04'!
requestSymbolCollection: caption
	^ (self requestStringCollection: caption) collect: [:each | each asSymbol] ! !

!Requestor methodsFor: 'requests' stamp: 'rr 3/14/2004 23:30'!
requestArgumentPermutation
	| selector oldArguments oldMethodName newMethodName class source |
	selector := self request: #selectorName.
	class := self request: #class.
	source := (MethodReference class: class selector: selector) sourceCode.
	oldArguments := (RBParser parseMethod: source) argumentNames.
	oldMethodName := RBMethodName selector: selector arguments: oldArguments.
	(newMethodName := MethodNameEditor forMethodName: oldMethodName) 
		ifNil: [^nil].
	^newMethodName arguments collect: [:e | oldArguments indexOf: e]! !

!Requestor methodsFor: 'executing' stamp: 'rr 3/14/2004 22:41'!
performRequest: parameterType 
	| param selector |
	caption := 'please enter ' , (self findWordsIn: parameterType).
	selector := ('request' , parameterType capitalized) asSymbol.
	param := self perform: (self fetchSelectorFor: selector).
	self cache: param category: parameterType.
	^param! !

!Requestor methodsFor: 'requests' stamp: 'rr 3/14/2004 23:19'!
requestMethodBody
	| m |
	m := FillInTheBlankMorph new.
	m setQuery: 'Please enter the full body of the method you want to define' 
		initialAnswer:  self class sourceCodeTemplate
		answerExtent: 500@250
		acceptOnCR: false. 
	World addMorph: m centeredNear: World activeHand position.
	^ m getUserResponse.! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/14/2004 19:11'!
requestString: caption
	| result |
	result := FillInTheBlank request: caption.
	result isEmpty | result isNil ifTrue: [ServiceCancelled signal].
	 ^ result! !

!Requestor methodsFor: 'executing' stamp: 'rr 3/14/2004 19:17'!
doesNotUnderstand: aMessage 
	"if it's a setter, sets in the dictionnary"

	(aMessage selector keywords size = 1 & aMessage selector last) = $: 
		ifTrue: 
			[args at: (aMessage selector copyWithout: $:)
				put: aMessage arguments first]
		ifFalse: [super doesNotUnderstand: aMessage]! !

!Requestor methodsFor: 'generic requests' stamp: 'rr 3/14/2004 19:11'!
requestStringCollection: caption
	^ ((self requestString: caption, Character cr asString, 'Separate items with space') 
	findTokens: ' ') collect: [:each | each copyWithoutAll: ' ' ]! !

!AbstractInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 20:36'!
helpText
	^ 'Creates accessors and selectors for the selected instance variable,
	and replaces all references and assignments to the iv in the code
	with call to the accessors'! !

!AbstractInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:46'!
parameters
	^ #(instanceVariableName class)! !

!AbstractInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:03'!
categories
	^ {self ivrc}! !

!AbstractInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:35'!
service
	^ Service new label: 'Abstract instance variable';
				shortLabel: 'Abstract iv';
				action: [:class :instanceVariableName |
					(self variable: instanceVariableName class: class) execute]! !

!RemoveClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 22:11'!
parameters
	^ #(classNameCollection)! !

!RemoveClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:57'!
constructor
	^ #classNames:! !

!RemoveClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 20:41'!
helpText
	^ 'Safely removes one or several classes'! !

!RemoveClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:05'!
service
	^ Service new label: 'Remove classes';
			action: [:classNameCollection | (self classNames: classNameCollection) execute]! !

TestCase subclass: #RequestorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Tests'!

!RequestorTest commentStamp: '<historical>' prior: 0!
A TestCase is a Command representing the future running of a test case. Create one with the class method #selector: aSymbol, passing the name of the method to be run when the test case runs.

When you discover a new fixture, subclass TestCase, declare instance variables for the objects in the fixture, override #setUp to initialize the variables, and possibly override# tearDown to deallocate any external resources allocated in #setUp.

When you are writing a test case method, send #assert: aBoolean when you want to check for an expected value. For example, you might say "self assert: socket isOpen" to test whether or not a socket is open at a point in a test.!

!RequestorTest methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 18:29'!
tearDown
	"I am called whenever your test ends. 
I am the place where you release the ressources"! !

!RequestorTest methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 18:29'!
setUp
	"I am the method in which your test is initialized. 
If you have ressources to build, put them here."! !

TestCase subclass: #ServiceTest
	instanceVariableNames: 'dummy dummy2 dummy3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Tests'!

!ServiceTest commentStamp: '<historical>' prior: 0!
A TestCase is a Command representing the future running of a test case. Create one with the class method #selector: aSymbol, passing the name of the method to be run when the test case runs.

When you discover a new fixture, subclass TestCase, declare instance variables for the objects in the fixture, override #setUp to initialize the variables, and possibly override# tearDown to deallocate any external resources allocated in #setUp.

When you are writing a test case method, send #assert: aBoolean when you want to check for an expected value. For example, you might say "self assert: socket isOpen" to test whether or not a socket is open at a point in a test.!

!ServiceTest methodsFor: 'testing' stamp: 'rr 3/15/2004 21:37'!
testExecute
		dummy execute.
		dummy2 execute.
		dummy3 execute! !

!ServiceTest methodsFor: 'initialize-release' stamp: 'rr 3/14/2004 18:05'!
tearDown
	"I am called whenever your test ends. 
I am the place where you release the ressources"! !

!ServiceTest methodsFor: 'initialize-release' stamp: 'rr 3/16/2004 20:55'!
setUp
	"I am the method in which your test is initialized. 
If you have ressources to build, put them here."

	dummy := ServiceOld 
				provider: self
				selector: #assertTrue
				requestor: TestRequestor new
				parameters: #().
	dummy2 := ServiceOld 
				provider: self
				selector: #assert:
				requestor: TestRequestor new
				parameters: #(#boolean).
	dummy3 := ServiceOld 
				provider: self
				selector: #assertSel:
				requestor: Requestor new
				parameters: #(#selectorName)! !

!ServiceTest methodsFor: 'dispatching' stamp: 'rr 3/14/2004 18:15'!
assertTrue
	self assert: true! !

!ServiceTest methodsFor: 'dispatching' stamp: 'rr 3/14/2004 21:43'!
assertSel: s
	self assert: s isSymbol! !

ServiceTest subclass: #ServiceCategoryTest
	instanceVariableNames: 'serviceCat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Tests'!

!ServiceCategoryTest commentStamp: '<historical>' prior: 0!
A TestCase is a Command representing the future running of a test case. Create one with the class method #selector: aSymbol, passing the name of the method to be run when the test case runs.

When you discover a new fixture, subclass TestCase, declare instance variables for the objects in the fixture, override #setUp to initialize the variables, and possibly override# tearDown to deallocate any external resources allocated in #setUp.

When you are writing a test case method, send #assert: aBoolean when you want to check for an expected value. For example, you might say "self assert: socket isOpen" to test whether or not a socket is open at a point in a test.!

!ServiceCategoryTest methodsFor: 'initialize-release' stamp: 'rr 3/15/2004 10:00'!
tearDown
	"I am called whenever your test ends. 
I am the place where you release the ressources"! !

!ServiceCategoryTest methodsFor: 'initialize-release' stamp: 'rr 3/15/2004 10:33'!
setUp
	"I am the method in which your test is initialized. 
If you have ressources to build, put them here."
	super setUp! !

!ServiceCategoryTest methodsFor: 'testing' stamp: 'rr 3/15/2004 10:32'!
testExecute
	serviceCat := ServiceCategory new.
	{dummy. dummy2. dummy3} do: [:each | serviceCat addService: each].
	serviceCat execute.! !

!MoveVariableDefinitionRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:18'!
constructor
	^ #bindTight:in:selector:  ! !

!MoveVariableDefinitionRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 19:27'!
helpText
	^ 'moves a variable declaration as close to its use as possible.
	I.e. if a variable is only used in a block, it''s declaration will
	be moved to the beginning of the block.'! !

!MoveVariableDefinitionRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:11'!
categories
	^{self selrc}! !

!MoveVariableDefinitionRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:39'!
parameters
	^ #(selection class selectorName) ! !

!MoveVariableDefinitionRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:19'!
service
	^ Service new label: 'Move variable declaration to innermost scope';
				shortLabel: 'bindTight';
				condition: self variableSelected;
				action: [:class :selector :selection |
					(self new bindTight: selection in: class selector:  selector) execute]
! !

!MoveVariableDefinitionRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:10'!
conditionBlock
	^ [:selectionNode | selectionNode isVariable]! !

!ExtractMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:09'!
constructor
	^ #extract:from:in:  ! !

!ExtractMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:17'!
categories
	^ {self selrc}! !

!ExtractMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:43'!
service
	^((Service new)
		label: 'Extract Method';
		shortLabel: 'Extract';
		"condition: self messageSendSelected;" "can extract anything"
		action: 
				[:class :selector :selection | 
				(self 
					extract: selection
					from: selector
					in: class) execute]) 
		! !

!ExtractMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:23'!
helpText
	^ 'Select a piece of text in a method.
	You will be prompted to enter a new method
	name. The new method will be created, and 
	a call will be inserted. If the selected code
	exists in another method, you will be asked
	whether to use the other method'! !

!ExtractMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 11:20'!
conditionBlock
	^  [:selectionNode | selectionNode isMessage]! !

!ExtractMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 23:28'!
parameters
	^ #(selection selectorName class)! !

!RenameMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:08'!
constructor
	^ #renameMethod:in:to:permuation:! !

!RenameMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:49'!
categories
	^ {self methrc}! !

!RenameMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:22'!
service
	^ Service new label: 'Rename method';
				shortLabel: 'Rename';
				action: [:class :selector :newSelectorName :argumentPermutation |
						(self renameMethod: selector in: class to: newSelectorName 
											permuation: argumentPermutation) execute]! !

!RenameMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 20:56'!
helpText
	^ 'Renames a method, and fixes all senders.
	You can if you want change the orders in
	which the arguments are passed to the
	new method'! !

!RenameMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:34'!
parameters
	^ #(selectorName class newSelectorName argumentPermutation)! !

!Refactoring class methodsFor: '*services-rb-queries' stamp: 'rr 3/17/2004 16:57'!
ivrc
	^#'Instance Variable/Refactorings'! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:14'!
assignmentSelected
	^ [:selectionNode | selectionNode isAssignment]! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 16:40'!
execute
	"creates a new refactoring and executes it, asking for the missing parameters"
	self factory execute! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/9/2004 23:12'!
executeWith: argArray
	"like execute, but a part of the parameters are allready provided"! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:14'!
variableSelected
	^ [:selectionNode | selectionNode isVariable]! !

!Refactoring class methodsFor: '*services-rb-queries' stamp: 'rr 3/17/2004 16:57'!
classvarrc
	^#'Class Variable/Refactorings'! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:41'!
parameters
	"Returns the parameters needed for the execute methods :
	their type, and the method to obtain them if they are missing :
	FillInTheBlank / SelectorEditor / Interval / MenuChoice"
	^ #()! !

!Refactoring class methodsFor: '*services-rb-queries' stamp: 'rr 3/17/2004 16:58'!
methrc
	^#'Method/Refactorings'! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 11:12'!
categories
	^ #(Refactorings)! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 11:27'!
isStandAlone
	"tells if this refactoring can be executed on its own, or if it is abstract or only called
	by other refactorings"
	^ false! !

!Refactoring class methodsFor: '*services-rb-queries' stamp: 'rr 3/17/2004 16:57'!
classrc
	^#'Class/Refactorings'! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 16:40'!
factory
	"creates a new refactoring for this refactoring class"
	^ RefactoringFactory new forClass: self! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:13'!
messageSendSelected
	^ [:selectionNode | selectionNode isMessage]! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:35'!
registerServices
	"register all know refactorings as services"
	| service |
	self allSubclassesDo: [:each |
		each isStandAlone ifTrue: [
			service := each service.
			service description: each helpText.
			Service register: service underCategories: each categories]] ! !

!Refactoring class methodsFor: '*services-rb-queries' stamp: 'rr 3/17/2004 16:58'!
selrc
	^#'Selection/Refactorings'! !

!Refactoring class methodsFor: '*services-rb-queries' stamp: 'rr 3/17/2004 16:58'!
temprc
	^#'Temporary Variable/Refactorings'! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:42'!
constructor
	"returns the selector to send to the class in order to build a new instance"
	^ #new! !

!Refactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 11:13'!
conditionBlock
	"answers the conditionblock for this refactoring"
	^ [self isStandAlone]! !

!PushDownClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:55'!
parameters
	^ #(classVariableName class)! !

!PushDownClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 23:31'!
helpText
	^ 'Push the definition of the selected class variable
	in ONE of the subclasses (duplicating it may break
	the code)'! !

!PushDownClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:31'!
service
	^ Service new label: 'Push down class variable';
				shortLabel: 'Push  down';
				action: [:class :classVariable | (self variable: classVariable class: class) execute]! !

!PushDownClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:11'!
categories
	^{self classvarrc}! !

!PasteUpMorph methodsFor: '*services-override' stamp: 'rr 3/16/2004 22:45'!
yellowButtonClickOnDesktopWithEvent: evt 
	"Put up either the personalized menu or the world menu when 
	the user clicks on the morphic desktop with the yellow button. 
	The preference 'personalizedWorldMenu' governs which one 
	is used"
"
	| aMenu |
	Preferences personalizedWorldMenu 
		ifTrue: [aMenu := self personalizeUserMenu: evt]
		ifFalse: 
			[aMenu := self buildWorldMenu: evt.
			aMenu addTitle: 'World' translated].
	aMenu popUpEvent: evt in: self"
	
	Service root execute! !

!Browser methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:30'!
findSelectionNode
	| node |
	node := self findNode.
	^ node ifNil: [RBProgramNode new] ifNotNil: [node]! !

!Browser methodsFor: '*services-rb-cutnpaste' stamp: 'rr 3/17/2004 17:42'!
parseSelection
	^RBParser parseExpression: self selectedText onError: [:str :pos | ^nil]! !

!Browser methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:36'!
newRequestor
	^BrowserRequestor new browser: self! !

!Browser methodsFor: '*services-rb' stamp: 'rr 3/17/2004 18:14'!
addCategory: aString to: aMenu 
	| cat |
	cat := Service categoryNamed: aString.
	cat requestor: self newRequestor.
	cat asMenuItemFor: aMenu! !

!Browser methodsFor: '*services-override' stamp: 'rr 3/17/2004 18:21'!
messageListMenu: aMenu shifted: shifted
	"Answer the message-list menu"
	"Changed by emm to include menu-item for breakpoints"
	self hookForMessageListIn: aMenu.
	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].

	aMenu addList:#(
			('what to show...'			offerWhatToShowMenu)
                	('toggle break on entry'		toggleBreakOnEntry)
            		-
			('browse full (b)' 			browseMethodFull)
			('browse hierarchy (h)'			classHierarchy)
			('browse method (O)'			openSingleMessageBrowser)
			('browse protocol (p)'			browseFullProtocol)
			-
			('fileOut'				fileOutMessage)
			('printOut'				printOutMessage)
			-
			('senders of... (n)'			browseSendersOfMessages)
			('implementors of... (m)'		browseMessages)
			('inheritance (i)'			methodHierarchy)
			('tile scriptor'			openSyntaxView)
			('versions (v)'				browseVersions)
			-
			('inst var refs...'			browseInstVarRefs)
			('inst var defs...'			browseInstVarDefs)
			('class var refs...'			browseClassVarRefs)
			('class variables'			browseClassVariables)
			('class refs (N)'			browseClassRefs)
			-
			('remove method (x)'			removeMessage)
			-
			('more...'				shiftedYellowButtonActivity)).
	^ aMenu
! !

!Browser methodsFor: '*services-rb-cutnpaste' stamp: 'rr 3/17/2004 17:33'!
findNode
	| tree node interval |
	interval := self selectedInterval.
	interval isEmpty ifTrue: [^nil].
	tree := RBParser parseMethod: self text
				onError: [:str :err | ^self parseSelection].
	node := tree whichNodeIsContainedBy: interval.
	node isNil ifTrue: [node := tree bestNodeFor: interval].
	^node! !

!Browser methodsFor: '*services-rb' stamp: 'rr 3/17/2004 18:16'!
hookForClassListIn: aMenu 
	{ 
		'Class'.
		'Instance Variable'.
		'Class Variable'} do: [:cat | self addCategory: cat to: aMenu]! !

!Browser methodsFor: '*services-override' stamp: 'rr 3/17/2004 18:20'!
codePaneMenu: aMenu shifted: shifted 

	self hookForCodePaneIn: aMenu.
	super codePaneMenu: aMenu shifted: shifted.
	^aMenu! !

!Browser methodsFor: '*services-rb' stamp: 'rr 3/17/2004 18:22'!
hookForCodePaneIn: aMenu 
	self addCategory: 'Selection/Refactorings' to: aMenu! !

!Browser methodsFor: '*services-rb-cutnpaste' stamp: 'rr 3/17/2004 17:43'!
selectedText
	| interval |
	interval := self selectedInterval.
	interval isEmpty ifTrue: [^''].
	^self codeTextMorph text asString copyFrom: interval first
		to: interval last! !

!Browser methodsFor: '*services-rb-cutnpaste' stamp: 'rr 3/17/2004 17:34'!
text
	^self contents! !

!Browser methodsFor: '*services-override' stamp: 'rr 3/17/2004 18:18'!
classListMenu: aMenu shifted: shifted
	"Set up the menu to apply to the receiver's class list, honoring the #shifted boolean"

	self hookForClassListIn: aMenu.
	shifted
		ifTrue:
			[^ self shiftedClassListMenu: aMenu].
	aMenu addList: #(
		-
		('browse full (b)'			browseMethodFull)
		('browse hierarchy (h)'		spawnHierarchy)
		('browse protocol (p)'		browseFullProtocol)
		-
		('printOut'					printOutClass)
		('fileOut'					fileOutClass)
		-
		('show hierarchy'			hierarchy)
		('show definition'			editClass)
		('show comment'			editComment)
		-
		('inst var refs...'			browseInstVarRefs)
		('inst var defs...'			browseInstVarDefs)
		-
		('class var refs...'			browseClassVarRefs)
		('class vars'					browseClassVariables)
		('class refs (N)'				browseClassRefs)
		-
		('rename class ...'			renameClass)
		('copy class'				copyClass)
		('remove class (x)'			removeClass)
		-
		('find method...'				findMethod)
		-
		('more...'					offerShiftedClassListMenu)).
	^ aMenu! !

!Browser methodsFor: '*services-rb' stamp: 'rr 3/17/2004 18:20'!
hookForMessageListIn: aMenu 
	self addCategory: 'Method/Refactorings' to: aMenu! !

!StringHolder methodsFor: '*services' stamp: 'rr 3/15/2004 09:17'!
codeTextMorph
	^ self dependents
		detect: [:dep | (dep isKindOf: PluggableTextMorph)
				and: [dep getTextSelector == #contents]]
		ifNone: []! !

!StringHolder methodsFor: '*services' stamp: 'rr 3/15/2004 09:17'!
selectedInterval
	^self codeTextMorph selectionInterval! !

!RemoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:42'!
parameters
	^ #(selectorCollection class)! !

!RemoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:00'!
categories
	^ {self classrc. self methrc}! !

!RemoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:27'!
service
	^ Service new label: 'Remove methods';
				action: [:class :selectorCollection | 
					(self removeMethods: selectorCollection from: class) execute] ! !

!RemoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:28'!
helpText
	^ 'Safely removes the selected method'! !

!RemoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:00'!
constructor
	^ #removeMethods:from:  ! !

!ExpandReferencedPoolsRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:30'!
isStandAlone
	^ false! !

!CompiledMethod methodsFor: '*services' stamp: 'rr 3/15/2004 14:58'!
asService
	"converts self to a service"
	^ MethodService new forMethod: self! !

!InlineMethodFromComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 10:35'!
helpText
	^ 'Select a message send to an iv or temp.
	You will be prompted to choose one implementation 
	of the message, this implementation will be inlined
	in place of the call'! !

!InlineMethodFromComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:34'!
service
	^ Service new label: 'Inline method from component';
				shortLabel: 'inline comp';
				action: self messageSendSelected;
				action: [:class :selector :selection | 
					(self inline: selection inMethod: selector forClass: class) execute ]! !

!ProtectInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:51'!
constructor
	^ #(instanceVariableName class)! !

!ProtectInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:56'!
helpText
	^ 'Replaces all accessor by direct accesses to the ivar.
	If the accessor are not sent, they are removed as well'! !

!ProtectInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:14'!
categories
	^ {self ivrc} ! !

!ProtectInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:40'!
service
	^ Service new label: 'Protect instance variable';
				shortLabel: 'protect iv';
				action: [:class :instanceVariable |
					(self variable: instanceVariable class: class) execute] ! !

!ChangeMethodNameRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:39'!
isStandAlone
	^  (self = ChangeMethodNameRefactoring) not! !

!SplitClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:39'!
constructor
	^ #class:instanceVariables:newClassName:referenceVariableName:! !

!SplitClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:19'!
helpText
	^ 'Create a new class at the same level than the old class,
	with the list of instance variable selected from the old class.
	These ivs are then removed from the old class.
	A new iv will be added, on which the request to the
	removed iv will be forwarded. Thus the new class
	will become a component of the old class.'! !

!SplitClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:42'!
service
	^ Service new label: 'Split class in two components';
				shortLabel: 'split';
				action: [:class :newClassName :instanceVariablesToMoveInTheNewClassCollection
					:newVariableWhereRequestsWillBeForwarded | 
					(self class: class 
						instanceVariables: instanceVariablesToMoveInTheNewClassCollection 
						newClassName: newClassName 
						referenceVariableName: newVariableWhereRequestsWillBeForwarded) 
							execute]! !

!SplitClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:13'!
categories
	^{self classrc}! !

!SplitClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:45'!
parameters
	^ #(class instanceVariablesToMoveToTheNewClassCollection 
		newClassName newVariableWhereRequestsWillBeForwardedName) ! !

!SplitClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:35'!
isStandAlone
	self flag: #refactoryrefactoring.
	^ true! !

!RenameClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:35'!
service
	^ Service new label: 'Rename class';
			action: [:class :newClassName | (self rename: class to: newClassName) execute]! !

!RenameClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:24'!
categories
	^ {self classrc}! !

!RenameClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:36'!
constructor
	^ #rename:to:! !

!RenameClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 23:13'!
helpText
	^ 'Renames a class. Warning, there seems
	to be a bug in PackageInfo/SystemChangeNotification
	when renaming a class'! !

!RenameClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:30'!
parameters
	^ #(class newClassName)! !

!InlineMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:36'!
parameters
	^ #(selection selectorName class)! !

!InlineMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:17'!
service
	^ Service new label: 'Inline method';
				shortLabel: 'inline';
				action: self messageSendSelected;
				action: [:class :selector :selection | 
					(self inline: selection inMethod: selector forClass: class) execute ]! !

!InlineMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:14'!
constructor
	^ #inline:inMethod:forClass:! !

!InlineMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:21'!
categories
	^ {self selrc}! !

!InlineMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 23:23'!
helpText
	^ 'select a self message send in the method.
	The body of this message will be inserted in
	the method'! !

!InlineMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:12'!
conditionBlock
	^ self messageSendSelected! !

Warning subclass: #ServiceCancelled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceCancelled methodsFor: 'as yet unclassified' stamp: 'rr 3/14/2004 19:14'!
messageText
	^ 'Service has been cancelled'! !

!RemoveParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:40'!
service
	^ Service new label: 'Remove parameter';
				shortLabel: 'Rm param';
				action: [:class :selector :parameterName |
					(self removeParameter: parameterName in: class selector: selector) execute] ! !

!RemoveParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:05'!
constructor
	^ #removeParameter:in:selector:! !

!RemoveParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:03'!
categories
	^ {self methrc} ! !

!RemoveParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:34'!
parameters
	^ #(nameOfTheParameter class selectorName)! !

!RemoveParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 10:54'!
helpText
	^ 'If a parameter is no more used in a method, you can remove
	it, and all senders will be updated'! !

!PushUpMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:22'!
categories
	^ {self methrc}! !

!PushUpMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:20'!
constructor
	^ #pushUp:from:! !

!PushUpMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:20'!
parameter
	^ #(selectorCollection class)! !

!PushUpMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:38'!
helpText
	^ 'Moves the selector to this class'' superclass'! !

!PushUpMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:08'!
service
	^ Service new label: 'push up methods';
			shortLabel: 'push up';
			description: 'TODO : enter this';
			action: [:class :selectorCollection | (self pushUp: selectorCollection from: class) execute]! !

!String methodsFor: '*services-rb' stamp: 'rr 3/15/2004 13:39'!
convertToWordIn: res 
	self do: 
			[:c | 
			c isUppercase 
				ifTrue: 
					[res
						nextPut: Character space;
						nextPut: c asLowercase]
				ifFalse: [res nextPut: c]]! !

!RemoveInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:01'!
categories
	^ {self ivrc} ! !

!RemoveInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:20'!
helpText
	^ 'Safely removes an iv'! !

!RemoveInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:57'!
parameters
	^ #(instanceVariableName class)! !

!RemoveInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:29'!
service
	^ Service new label: 'Remove instance variable';
				shortLabel: 'Remove iv';
				action: [:class :instanceVariableName | 
						(self remove: instanceVariableName from: class) execute] ! !

!RenameInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 10:38'!
helpText
	^ 'Renames an instance variable,
	and update all references to it'! !

!RenameInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:56'!
constructor
	^ #rename:to:in:! !

!RenameInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:37'!
service
	^ Service new label: 'Rename instance variable';
				shortLabel: 'rename iv';
				action: [:class :instanceVariable :newInstanceVariableName |
					(self rename: instanceVariable to: newInstanceVariableName in: class) execute]  ! !

!RenameInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:09'!
categories
	^ {self ivrc}! !

!RenameInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:58'!
parameters
	^ #(instanceVariableName newInstanceVariableName class)! !

!PullUpClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:52'!
constructor
	^ #(subclassDefinedClassVariableName class)! !

!PullUpClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:31'!
helpText
	^ 'Select a class and a class var defined
	in one of it''s subclasses. The definition
	will be moved in the class'! !

!PullUpClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:15'!
categories
	^ {self classvarrc}! !

!PullUpClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:42'!
service
	^ Service new label: 'Pull up class variable';
				shortLabel: 'pull up';
				action: [:class :subclassDefinedClassVariableName |
					(self variable: subclassDefinedClassVariableName class: class) execute] ! !

!AddClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:44'!
service
	^ Service new label: 'Add class variable';
				shortLabel: 'add';
				action: [:class :newClassVariableName |
					(self variable: newClassVariableName class: class) execute] ! !

!AddClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:52'!
helpText
	^ 'Adds the class variable to the class'! !

!AddClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:16'!
categories
	^ {self classvarrc}! !

!AddClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:47'!
parameters
	^ #(newClassVariableName class) ! !

!RenameClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:53'!
constructor
	^ #rename:to:in:! !

!RenameClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:13'!
categories
	^ {self classvarrc}! !

!RenameClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:38'!
service
	^ Service new label: 'Rename class variable';
				shortLabel: 'Rename';
				action: [:class :classVariableName :newVariableName|
					(self rename: classVariableName to: newVariableName in: class) execute] ! !

!RenameClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:57'!
parameters
	^ #(classVariableName newClassVariableName class)! !

!RenameClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 10:48'!
helpText
	^ 'Renames a class variable, and update
	all references to it.'! !

!ExtractMethodToComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:44'!
service
	^ Service new label: 'Extract method to component';
				shortLabel: 'Extract';
				"condition: self messageSendSelected;" "can extract anything"
				action: [:class :selector :selection |
					(self extract: selection from: selector in: class) execute] ! !

!ExtractMethodToComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:12'!
categories
	^{self selrc}! !

!ExtractMethodToComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 12:59'!
conditionBlock
	^ [:selectionNode | selectionNode isMessage]! !

!ExtractMethodToComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:11'!
constructor
	^ #extract:from:in:  ! !

!ExtractMethodToComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:45'!
helpText
	^ 'Select a piece of code and an instance or temporary variable.You will then have to choose in this iv''s possible types which one you want to select.The code will be compiled in those classes, and the code will be replaced by a method call on the selected iv.'! !

!ExtractMethodToComponentRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:35'!
parameters
	^ #(selection selectorName class)! !

!ExtractToTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:17'!
service
	^ Service new label: 'Extract to temporary variable';
					shortLabel: 'Extract temp';
					condition: self variableSelected;
					action: [:class :selector :selection :newTemporaryVariableName |
							(self extract: selection to: newTemporaryVariableName  
									from: selector in: class) execute ]! !

!ExtractToTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 20:39'!
helpText
	^ 'Converts the selected expression in the code to an
	assignment in a temporary variable.'! !

!ExtractToTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:12'!
constructor
	^ #extract:to:from:in:! !

!ExtractToTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:20'!
categories
	^ {self selrc}! !

ExtractToTemporaryRefactoring subclass: #ExtractToResultRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-RB'!

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:29'!
insertTemporary
	| node statementNode |
	node := self parseTree whichNodeIsContainedBy: sourceInterval.
	(node notNil and: [node isValue]) 
		ifFalse: [self refactoringError: 'Cannot assign to non-value nodes'].
	statementNode := node statementNode.
	node replaceWith: (RBVariableNode named: newVariableName).
	(statementNode parent)
		addNode: (self constructAssignmentFrom: node)
			before: (node == statementNode 
					ifTrue: [RBVariableNode named: newVariableName]
					ifFalse: [statementNode]).
	parseTree body addTemporaryNamed: newVariableName! !

!ExtractToResultRefactoring class methodsFor: 'services-rb' stamp: 'rr 3/17/2004 17:06'!
service
	^ Service new label: 'Extract to temporary variable, and return result';
					shortLabel: 'Extract res';
					condition: self variableSelected;
					action: [:class :selector :selection :newTemporaryVariableName |
							(self extract: selection to: newTemporaryVariableName  
									from: selector in: class) execute ]! !

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2004 22:07'!
helpText
	^ 'Select some code in a method. This code
	will be extracted to a temporary and this
	temporary will be returned by the method'! !

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:06'!
transform
	self
		insertTemporary;
		insertResult;
		compileNewMethod! !

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:16'!
insertResult
	| node |
	parseTree lastIsReturn ifTrue: [^self halt].
	node := RBReturnNode value: (RBVariableNode named: newVariableName).
	parseTree addNode: node! !

!ExtractToResultRefactoring class methodsFor: 'services-rb' stamp: 'rr 3/17/2004 17:08'!
categories
	^ {self selrc}! !

!ExtractToResultRefactoring class methodsFor: 'services-rb' stamp: 'rr 3/17/2004 17:07'!
helpText
	^ 'Extracts the selected expression to a temporary, and returns it as the 
	result of this message'! !

!ExtractToTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:36'!
parameters
	^ #(selection newTemporaryVariableName selectorName class)! !

!ExtractToTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:09'!
conditionBlock
	^ [:selectionNode | selectionNode isVariable]! !

!PushDownMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:39'!
parameters
	^ #( selectorCollection class)! !

!PushDownMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:03'!
service
	^ Service new label: 'push down methods';
				shortLabel: 'push down';
				action: [:class :selectorCollection | 
					(self pushDown: selectorCollection from: class) execute]! !

!PushDownMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:24'!
categories
	^ {self methrc}! !

!PushDownMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:19'!
constructor
	^ #pushDown:from:  ! !

!PushDownMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 19:31'!
helpText
	^ 'Move a method in all of the subclasses of a class.
	It''s definition can be duplicated if there are several
	subclasses.'! !

!ClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 13:15'!
isClassRefactoring
	^ true! !

!ClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 11:14'!
categories
	^ super categories, #('Class/Class Refactorings')! !

!ClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:39'!
isStandAlone
	^ (self =  ClassRefactoring) not! !

!AddClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:33'!
constructor
	^ #addClass:superclass:subclasses:category:! !

!AddClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:25'!
parameters
	^ #(newClassName class subclassNameCollection categoryName)! !

!AddClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:50'!
service
	^ Service new label: 'New class';
				action: [:newClassName :classCategoryName :class :classCollection|
					(self addClass: newClassName superclass: class  
							subclasses: classCollection category: classCategoryName) execute] ! !

!AddClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 19:47'!
helpText
	^ 'Create a new subclass of a class. You can also name
	some of the class''s subclasses to become subclasses
	of the newly created class'! !

!AddClassRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:17'!
categories
	^ {self classrc}! !

!AbstractClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:54'!
helpText
	^ 'Replaces all direct accesses to the class var by
	message sends to the class'! !

!AbstractClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:46'!
parameters
	^ #(classVariableName class)! !

!AbstractClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:10'!
categories
	^{self classvarrc}! !

!AbstractClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:33'!
service
	^ Service new label: 'Abstract class variable';
				shortLabel: 'abstract';
				action: [:class :classVariable | (self variable: classVariable class: class) execute]! !

!VariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:43'!
constructor
	^ #variable:class:! !

!VariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:58'!
categories
	^ super categories, #('Variable/Variable Refactorings')! !

!VariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:45'!
parameters
	^ #(variableName class)! !

!VariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:40'!
isStandAlone
	^ (self = VariableRefactoring) not! !

!BlockContext methodsFor: '*services' stamp: 'rr 3/16/2004 20:55'!
asService
	"returns a service executing self"

	| s |
	s := ServiceOld new.
	s provider: self fixTemps.
	s parameters: self tempNames.
	s selector: self valueSelector.
	^s! !

!BlockContext methodsFor: '*services' stamp: 'rr 3/15/2004 11:33'!
valueSelector
	"a bit of a hack ..."
	^{ 
		#value.
		#value:.
		#value:value:.
		#value:value:value:.
		#value:value:value:value:} at: self numArgs + 1! !

!BlockContext methodsFor: '*services' stamp: 'rr 3/17/2004 11:09'!
arguments
	"A probably very slow way to get the arguments of a block"
	| source arguments |
	self numArgs = 0 ifTrue: [^ #()].
	source := self decompile.
	source ifNil: [self inform: 'cannot fetch block arguments'. ServiceCancelled signal]
			ifNotNil: [source := source printString].
	source := source copyUpTo: $|.
	source := source copyAfter: $[.
	arguments := (source findTokens: ':') collect: [:each | each withBlanksTrimmed].
	^ arguments! !

!BlockContext methodsFor: '*services' stamp: 'rr 3/15/2004 11:23'!
asServiceNamed: label
	"returns a service executing self, named as the argument"
	^ (self asService) label: label; yourself! !

!FillInTheBlankMorph methodsFor: '*services' stamp: 'rr 3/10/2004 19:09'!
selection
	^ textPane selectionInterval! !

!AddMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:31'!
parameters
	^ #(methodBody class methodCategoryName)! !

!AddMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:24'!
service
	^ Service new label: 'Add method';
				action: [:class :methodCategoryName :methodBody |
					(self addMethod: methodBody toClass: class
						 inProtocols:  methodCategoryName) execute]! !

!AddMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:02'!
constructor
	^ #addMethod:toClass:inProtocols:  ! !

!AddMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 10:37'!
helpText
	^ 'Enter the method name and body, 
	the class to implement it in, and
	the method category to classify
	the new method'! !

!AddMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:00'!
categories
	^ {self classrc. self methrc}! !

!RenameTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:57'!
helpText
	^ 'Renames a temporary variable !!'! !

!RenameTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 12:55'!
service
	^ Service new label: 'Rename temporary variable';
				shortLabel: 'Rename';
				action: [:class :selector :selection :newTemporaryName |
					(self renameTemporaryFrom: selection to: newTemporaryName 
								in: class  selector: selector) execute]   ! !

!RenameTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 12:55'!
conditionBlock
	^ [:selectionNode | selectionNode isVariable]! !

!RenameTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:59'!
constructor
	^ #renameTemporaryFrom:to:in:selector: ! !

!RenameTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:42'!
parameters
	^ #(selection newTemporaryName class selectorName)! !

!RenameTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:17'!
categories
	^ {self selrc}! !

!InlineParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:12'!
categories
	^{self methrc}! !

!InlineParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:32'!
service
	^ Service new label: 'Inline parameter';
				shortLabel: 'inline param';
				action: [:class :selector :parameterName |
					(self inlineParameter: parameterName in: class selector: selector) execute] ! !

!InlineParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:43'!
helpText
	^ 'Converts the parameter to a temporary variable.
	Works if all the calls to the message gives the
	same literal value to the parameter.
	The parameter is then removed from the message'! !

!InlineParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:07'!
constructor
	^ #inlineParameter:in:selector:  ! !

!AbstractVariablesRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:28'!
isStandAlone
	^ false! !

!InlineTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 13:18'!
service
	^ Service new label: 'Inline Temporary';
			shortLabel: 'inline';
			condition: self assignmentSelected;
			action: [:class :selector :selection | (self inline: selection from: selector in: class) execute]! !

!InlineTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:37'!
parameters
	^ #(selection selectorName class)! !

!InlineTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:15'!
constructor
	^ #inline:from:in:  ! !

!InlineTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 12:56'!
conditionBlock
	"Maybe be more precise i.e. could be an iv/...? "
	^ [:selectionNode | selectionNode isAssignment]! !

!InlineTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:19'!
categories
	^ {self selrc}! !

!InlineTemporaryRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:16'!
helpText
	^ 'Select an assignment to a temp.
	All references to the temp will be replaced
	by the right part of the assignment.'! !

!SystemNavigation class methodsFor: '*services' stamp: 'rr 3/15/2004 16:27'!
sendersListOf: selectorName navigator: systemNavigation
	"Method/Senders of..."
	"Browse all senders of the given method"
	
	^ systemNavigation allCallsOn: selectorName! !

!SystemNavigation class methodsFor: '*services' stamp: 'rr 3/15/2004 16:26'!
sendersOf: selectorName navigator: systemNavigation
	"Method/Senders of..."
	"Browse all senders of the given method"
	
	systemNavigation browseAllCallsOn: selectorName! !

!SystemNavigation class methodsFor: '*services' stamp: 'rr 3/15/2004 14:28'!
services
	^ {self>>#browseAllCallsOn:}! !

!AddInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 19:23'!
helpText
	^ 'Adds an instance variable to the selected class'! !

!AddInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:47'!
parameters
	^ #(newInstanceVariableName class)! !

!AddInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:04'!
service
	^ Service new label: 'Add instance variable';
				shortLabel: 'add iv';
				action: [:class :newInstanceVariableName | 
					(self variable: newInstanceVariableName class: class) execute]! !

!AddInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:08'!
categories
	^ {self ivrc}! !

!PullUpInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:54'!
helpText
	^ 'Select a class and an instance variable 
	defined in one of it''s subclasses. 
	The definition will be moved in the class'! !

!PullUpInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:20'!
categories
	^ {self ivrc}! !

!PullUpInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:55'!
constructor
	^ #(subclassDefinedInstanceVariableName class)! !

!PullUpInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:43'!
service
	^ Service new label: 'Pull up instance variable';
				shortLabel: 'pull up iv';
				action: [:class :subclassDefinedInstanceVariableName |
					(self variable: subclassDefinedInstanceVariableName class: class) execute] ! !

!AddParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:04'!
constructor
	^ #addParameterToMethod:in:newSelector:initializer:! !

!AddParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:18'!
categories
	^ {self methrc} ! !

!AddParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:27'!
helpText
	^ 'Adds a parameter to the method.
	Requests the new message name,
	and an initialization expression for
	the new parameter to insert in all
	senders of the message'! !

!AddParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:32'!
parameters
	^ #(selectorName class newSelectorName initializingExpressionForTheNewParameter) ! !

!AddParameterRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:59'!
service
	^ Service new label: 'Add parameter';
				action: [:class :selector :newSelectorName :initializingExpressionForTheNewParameter|
					(self addParameterToMethod: selector in: class newSelector: newSelectorName 
						initializer: initializingExpressionForTheNewParameter) execute ]! !

!TemporaryToInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:58'!
constructor
	^ #class:selector:variable:  ! !

!TemporaryToInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:01'!
service
	^ Service new label: 'Convert temporary to instance variable';
				label: 'convert';
				action: [:class :selector :temporary |
					(self class: class selector: selector variable: temporary) execute ]! !

!TemporaryToInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 19:35'!
helpText
	^ 'Converts a temporary variable in a method
	to an instance variable of the class'! !

!TemporaryToInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:43'!
parameters
	^ #(class selectorName temporaryName)! !

!TemporaryToInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:04'!
categories
	^ {self temprc.} ! !

!InlineAllSendersRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 09:59'!
helpText
	^ 'Inlines all the call to the selected message sent by self.
	If the message is not called anywhere else, it is removed '! !

!InlineAllSendersRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:04'!
categories
	^ {self methrc}! !

!InlineAllSendersRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:36'!
parameters
	^ #(selectorName class)! !

!InlineAllSendersRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:13'!
constructor
	^ #sendersOf:in:! !

!InlineAllSendersRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:57'!
service
	^ Service new label: 'Inline all self-sends';
			shortLabel: 'inline';
			action: [:class :selector | (self sendersOf: selector in: class) execute] ! !

!CreateAccessorsForVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:49'!
constructor
	^ #variable:class:! !

CreateAccessorsForVariableRefactoring subclass: #CreateAccessorsForInstanceVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-RB'!

!CreateAccessorsForInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:52'!
service
	^ Service new label: 'Create accessors for instance variable';
				shortLabel: 'iv accessors';
				action: [:class :instanceVariable |
					(self variable: instanceVariable class: class) execute] ! !

!CreateAccessorsForInstanceVariableRefactoring class methodsFor: 'instance creation' stamp: 'rr 3/10/2004 14:52'!
variable:  varName class: aClass
	^ self variable: varName class:  aClass classVariable: false! !

!CreateAccessorsForInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:50'!
parameters
	^ #(instanceVariableName class)! !

!CreateAccessorsForInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:51'!
isStandAlone
	^ true! !

!CreateAccessorsForInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:36'!
helpText
	^ 'Creates getters and setters for the selected instance variable'! !

!CreateAccessorsForInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:18'!
categories
	^ {self ivrc}! !

!CreateAccessorsForVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 14:48'!
isStandAlone
	"we create two subclasses, one for each case, instead of feeding a boolean"
	^ false! !

CreateAccessorsForVariableRefactoring subclass: #CreateAccessorsForClassVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-RB'!

!CreateAccessorsForClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:50'!
isStandAlone
	^ true! !

!CreateAccessorsForClassVariableRefactoring class methodsFor: 'instance creation' stamp: 'rr 3/10/2004 14:52'!
variable:  varName class: aClass
	^ self variable: varName class:  aClass classVariable: true! !

!CreateAccessorsForClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:52'!
service
	^ Service new label: 'Create accessors for class variable';
				shortLabel: 'accessors';
				action: [:class :classVariable |
					(self variable: classVariable class: class) execute] ! !

!CreateAccessorsForClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:37'!
helpText
	^ 'Creates getters and setters for the selected class variable'! !

!CreateAccessorsForClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:10'!
categories
	^{self classvarrc}! !

!CreateAccessorsForClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:49'!
parameters
	^ #(classVariableName class)! !

!FinderTool class methodsFor: '*services' stamp: 'rr 3/15/2004 16:21'!
codeFinderService 
	"World Menu/Open/Code finder"
	"A tool for finding and browsing patterns of code"
	self open! !

!FinderTool class methodsFor: '*services' stamp: 'rr 3/15/2004 16:19'!
services
	^ {[self open] . 'Code finder'. 'A tool for finding and browsing patterns of code'}! !

!FinderTool class methodsFor: '*services' stamp: 'rr 3/15/2004 16:26'!
codeFinder
	"World Menu/Open/Code finder"
	"A tool for finding and browsing patterns of code"
	
	self open! !

!PushDownInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:15'!
categories
	^ {self ivrc}! !

!PushDownInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 14:41'!
service
	^ Service new label: 'Push down instance variable';
				shortLabel: 'push down iv';
				action: [:class :instanceVariable |
					(self variable: instanceVariable class: class) execute] ! !

!PushDownInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 23:19'!
helpText
	^ 'Pushes the selected instance variable in
	the subclasse of the class. It will only be defined
	where it is really used'! !

!PushDownInstanceVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:56'!
parameters
	^ #(instanceVariableName class)! !

!MethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 11:16'!
categories
	^ super categories, #('Method/Method Refactorings')! !

!MethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:01'!
isStandAlone
	^ (self = MethodRefactoring) not! !

!RemoveClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:56'!
parameters
	^ #(classVariableName  class)! !

!RemoveClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 15:38'!
service
	^ Service new label: 'Remove class var';
				shortLabel: 'remove';
				action: [:class :classVariable | (self variable: classVariable class: class) execute]! !

!RemoveClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:23'!
categories
	^ {self classrc}! !

!RemoveClassVariableRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:53'!
helpText
	^ 'Removes the selected class variable'! !

!Array methodsFor: '*services' stamp: 'rr 3/15/2004 16:04'!
asBasicService
	| s |
	s := self first asService.
	self addDescriptionTo: s.
	^s! !

!Array methodsFor: '*services' stamp: 'rr 3/15/2004 16:04'!
addDescriptionTo: s 
	s label: self second.
	self size > 2 ifTrue: [s description: self third]! !

!Array methodsFor: '*services' stamp: 'rr 3/15/2004 16:07'!
asCompositeService
	| s |
	s := ServiceCategory new.
	self first do: [:each | s addService: each asService].
	self addDescriptionTo: s. 
	^ s! !

!Array methodsFor: '*services' stamp: 'rr 3/15/2004 16:06'!
asService
	^ self isCompositeService ifTrue: [self asCompositeService]
						ifFalse: [self asBasicService] ! !

!Array methodsFor: '*services' stamp: 'rr 3/15/2004 16:03'!
isCompositeService 
	"We are composite if our first element is also an array"
	^ self first isKindOf: Array! !

!MoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/11/2004 11:51'!
helpText
	^ 'Moves the definition of the method to an instance variable
	of the class. The message definition is then forwarded to the iv'! !

!MoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/14/2004 22:37'!
parameters
	^ #(selectorName class variableName)! !

!MoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 17:23'!
categories
	^ {self methrc} ! !

!MoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/10/2004 15:17'!
constructor
	^ #selector:class:variable:! !

!MoveMethodRefactoring class methodsFor: '*services-rb' stamp: 'rr 3/17/2004 16:05'!
service
	^ Service new label: 'Move method to variable';
			shortLabel: 'move';
			action: [:class :selector :variable | 
				(self selector: selector class: class variable: variable) execute ] ! !

!CodeHolder methodsFor: '*services' stamp: 'rr 3/15/2004 09:21'!
requestor
	^ (BrowserRequestor new) browser: self; yourself! !
Service initialize!
